use crate::dir_writer::{FileCollector, LanguageFeatures};

#[derive(Default)]
pub(super) struct RubyLanguageFeatures {}

impl LanguageFeatures for RubyLanguageFeatures {
    fn content_prefix(&self) -> &'static str {
        // "typed: strict" is set on a per-file basis in Ruby
        r#"
###############################################################################
#
#  Welcome to Baml! To use this generated code, please run the following:
#
#  $ bundle add baml sorbet-runtime sorbet-coerce sorbet-struct-comparable
#
###############################################################################

# This file was generated by BAML: please do not edit it. Instead, edit the
# BAML files and re-generate this code.
#
# frozen_string_literal: true
# rubocop: disable
# formatter:off
        "#
        .trim()
    }

    fn to_file_path(&self, name: &str) -> std::path::PathBuf {
        std::path::PathBuf::from(name.to_lowercase()).with_extension("rb")
    }
}

pub(super) trait ToRuby {
    fn to_ruby(&self) -> String;
}
